package controle;

import java.io.IOException;
import java.io.PrintWriter;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import model.Cidade;
import model.Contato;
import model.ContatoDAO;

public class ContatoControle extends HttpServlet {

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        SegurancaControle.verificarAcesso(request, response);
        
        String acao = request.getParameter("acao");
        PrintWriter resposta = response.getWriter();
        resposta.write("<script>");
        
        if ( acao != null ){
            
            String id = request.getParameter("id");
            if ( id != null && !id.isEmpty() && !id.equals("0") ) {
                ContatoDAO dao = new ContatoDAO();
                int idContato = Integer.parseInt(id);
                
                switch( acao )
                {
                    case "excluir":
                        if ( dao.excluir(idContato) ) {
                            resposta.print("alert('Contato excluído com sucesso!');");
                            resposta.print("location.href='index.jsp';");
                        }
                        break;
                        
                    case "alterar":
                        Contato contato = dao.recuperarPorId(idContato);
                        if( contato == null ) {
                            resposta.print("alert('Contato não encontrado!');");
                            resposta.print("history.back();");
                        } else {
                            request.setAttribute("c", contato);
                            request.getRequestDispatcher("/cadastro.jsp").forward(request, response);
                        }
                        break;
                }

            } else {
                resposta.write("alert('ID Inválido!');");
                resposta.write("history.back();");
            }
            
        } else {
            
            resposta.write("alert('Ação Inválida!');");
            resposta.write("history.back();");
                
        }
        
        resposta.write("</script>");
        resposta.close();  
    }

   
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        SegurancaControle.verificarAcesso(request, response);
        
        PrintWriter resposta = response.getWriter();
        
        String id = request.getParameter("id");
        String nome = request.getParameter("nome");
        String telefone = request.getParameter("telefone");
        String email = request.getParameter("email");
        
        Contato contato = new Contato();
        contato.setNome(nome);
        contato.setEmail(email);
        contato.setTelefone(telefone);
        
        String cidadeId = request.getParameter("cidade");
        
        if ( cidadeId != null && !cidadeId.isEmpty() ) {
            Cidade cidade = new Cidade();
            cidade.setId( Integer.parseInt(request.getParameter("cidade")) );
        
            contato.setCidade(cidade);
        } else {
            resposta.write("<script>alert('Selecione a cidade!');history.back();</script>");
            return;
        }
        
        ContatoDAO dao = new ContatoDAO();
        boolean sucesso = false;
        String mensagem = "";
        if ( id != null && !id.isEmpty() && !id.equals("0") ) {
            int idContato = Integer.parseInt(id);
            contato.setId(idContato);
            sucesso = dao.alterar(contato);
            mensagem = "Contato alterado com sucesso!";
        } else {            
            sucesso = dao.inserir(contato);
            mensagem = "Contato cadastrado com sucesso!";
        }   
        
        if ( sucesso == true ) {
            resposta.print("<h1>"+mensagem+"</h1>");
            resposta.print("<a href='index.jsp'>voltar</a>");
            // Consegui gravar
        } else {
            // Não consegui gravar
            resposta.print("<h1 style='color:red'>ERRO AO GRAVAR CONTATO</h1>");
            resposta.print("<a href='javascript:history.back()'>voltar</a>");
        }
        resposta.close();        
    }

}
