/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controle;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import model.Menu;
import model.Perfil;
import model.PerfilDAO;

import model.Usuario;
import model.UsuarioDAO;

public class SegurancaControle extends HttpServlet {
    
    private static HttpServletResponse response;
    
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        request.getSession().removeAttribute("usuario");
        response.sendRedirect("login.jsp");
    }

    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        SegurancaControle.response = response;
        
        String login = request.getParameter("usuario");
        String senha = request.getParameter("senha");
        ArrayList<String> erros = new ArrayList<String>();
        
        if ( login == null || login.trim().isEmpty()) {
            erros.add("Preencha o usuário.");
        }
        
        if ( senha == null || senha.trim().isEmpty()) {
            erros.add("Preencha a senha.");
        }
        
        if ( erros.size() > 0 ) {
            String campos = "";
            for(String erro : erros) {
                campos += "\\n-" + erro;                
            }
            exibirMensagem("Preencha o(s) campo(s):" +campos);
        } else {
            // Começa autenticação no banco de dados
            UsuarioDAO daoUsuario = new UsuarioDAO();
            Usuario usuario = daoUsuario.recuperarPorLogin(login);

            if ( usuario != null && usuario.getSenha().equals(senha) ) {
                
                PerfilDAO daoPerfil = new PerfilDAO();
                Perfil perfil = daoPerfil.recuperarPorId( usuario.getPerfil().getId() );

                if ( perfil == null || perfil.getMenus() == null ) {
                    exibirMensagem("Usuário/Senha inválido(s)!");
                } else {
                    
                    usuario.setPerfil(perfil);

                    HttpSession sessao = request.getSession();
                    sessao.setAttribute("usuario", usuario);

                    response.sendRedirect("/index.jsp");
                    
                }

                
            } else {
                exibirMensagem("Usuário/Senha inválido(s)!");
            }
            
        }
        
    }

    public static Usuario verificarAcesso(HttpServletRequest request, HttpServletResponse response) {
        Usuario usuario = null;
        SegurancaControle.response = response;
        try {
            HttpSession sessao = request.getSession();
            if ( sessao.getAttribute("usuario") == null ) {
                response.sendRedirect("login.jsp");
            } else {
                String uri = request.getRequestURI();
                String queryString = request.getQueryString();
                if ( queryString != null ) {
                    uri += "?" + queryString;
                }
                usuario = (Usuario)request.getSession().getAttribute("usuario");
                if ( usuario == null ) {
                    sessao.setAttribute("mensagem", "Você não está autenticado");
                    response.sendRedirect("login.jsp");
                } else {
                    boolean possuiAcesso = false;
                    for(Menu m : usuario.getPerfil().getMenus()) {
                        if ( uri.contains(m.getPagina()) ) {
                            possuiAcesso = true;
                            break;
                        }
                    }
                    
                    if ( !possuiAcesso ) {
                        exibirMensagem("Acesso negado!");
                    }
                }
            }
            
        } catch(Exception e) {
            e.printStackTrace();
        }
        return usuario;
    }
    
    private static void exibirMensagem(String mensagem) {
        try {
            PrintWriter out = response.getWriter();
            out.print("<script>");
            out.print("alert('" + mensagem + "');");
            out.print("history.back();");
            out.print("</script>");
            out.close();
        } catch( Exception e ) {
            e.printStackTrace();
        }
    }
}
